#!/bin/sh

# Terminal width: 132 columns.


unset SRC_DIR PUB_DIR DST_DIR TMP_DIR TPL_DIR SITEMAP XLAT XLAT_OPTS1 XLAT_OPTS2 XLAT_OPTS3 RSYNC RSYNC_OPTS ADDRESS PYTHON

while getopts 's:p:d:t:l:m:x:1:2:3:r:o:a:y:' c
do
	case $c in
	s)  SRC_DIR="${OPTARG}"     ;;
	p)  PUB_DIR="${OPTARG}"     ;;
	d)  DST_DIR="${OPTARG}"     ;;
	t)  TMP_DIR="${OPTARG}"     ;;
	l)  TPL_DIR="${OPTARG}"     ;;
	m)  SITEMAP="${OPTARG}"     ;;
	x)  XLAT="${OPTARG}"        ;;
	1)  XLAT_OPTS1="${OPTARG}"  ;;
	2)  XLAT_OPTS2="${OPTARG}"  ;;
	3)  XLAT_OPTS3="${OPTARG}"  ;;
	r)  RSYNC="${OPTARG}"       ;;
	o)  RSYNC_OPTS="${OPTARG}"  ;;
	a)  ADDRESS="${OPTARG}"     ;;
	y)  PYTHON="${OPTARG}"      ;;
	*)  :                       ;;
	esac
done


cat << HERE
Make targets available:

all      Make "sitemap", "files", "sync", and "pages" targets below.
sitemap  Rebuild the site map files.
files    Rebuild list of website pages for "pages" target.
sync     Sync and stage static content from '\$PUB_DIR/' to '\$DST_DIR/'.
pages    Compile all pages in '\$SRC_DIR/*.txt', stage in '\$DST_DIR/*.html'.
test     Run test server to browse staged website before upload.
upload   Upload staged website to live website server.
check    Make sure that the above make targets are likely to work properly.
new      Set up directories and files for a new website.
help     Show this help.

Current settings:

SRC_DIR:     ${SRC_DIR}
PUB_DIR:     ${PUB_DIR}
DST_DIR:     ${DST_DIR}
TMP_DIR:     ${TMP_DIR}
TPL_DIR:     ${TPL_DIR}
SITEMAP:     ${SITEMAP}
XLAT:        ${XLAT}
XLAT_OPTS1:  ${XLAT_OPTS1}
XLAT_OPTS2:  ${XLAT_OPTS2}
XLAT_OPTS3:  ${XLAT_OPTS3}
RSYNC:       ${RSYNC}
RSYNC_OPTS:  ${RSYNC_OPTS}
ADDRESS:     ${ADDRESS}
PYTHON:      ${PYTHON}

Edit 'config.mk' if you want to change any of these settings.
HERE


# End.

