#define _XOPEN_SOURCE 600
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

int main(int argc, char *argv[]) {

	/*
	 * Usage string broken in two because C90 compilers are not required to
	 * support string literals longer than 509 bytes.
	 */
	char errmsg1[] =
	"\n"

	"Usage: strptime date_string date_format [output_format]\n"
	"Where:\n"
	"\tdate_string is the date string to interpret,\n"
	"\tdate_format is the format string that made date_string, and\n"
	"\toutput_format is the format string for printing the result.\n"
	"\n"
	"If output_format is omitted:\n"
	"\tThe format string \"%S %M %H %d %m %Y %w %j %z%n\" is used.\n"
	"\n";
	char errmsg2[] =
	"This utility abuses strptime(3) to let shellscripts extract date\n"
	"and time data for arbitrary dates and times on systems where\n"
	"date(1) works exclusively with the current date and time.\n"
	"\n"
	"See date(1) and strftime(3) for date format string options.\n"
	"Note that some systems may not have some of the format options that\n"
	"you want, such as \"%s\".  See POSIX for the most common options.\n"

	"\n";

	struct tm tme; time_t now;
	char inp[255]; char fmt[255]; char out[255];
	char outfmt[255]; char outdef[] = "%S %M %H %d %m %Y %w %j %z%n";

	if (argc < 3) {
		fprintf(stderr, "%s", errmsg1);
		fprintf(stderr, "%s", errmsg2);
		exit(1);
	}

	memset(inp, 0, sizeof(inp)); memset(fmt, 0, sizeof(fmt));
	memset(out, 0, sizeof(out)); memset(outfmt, 0, sizeof(outfmt));
	strncpy(inp, argv[1], sizeof(inp) - 1);
	strncpy(fmt, argv[2], sizeof(fmt) - 1);

	memset(&tme, 0, sizeof(struct tm));
	time(&now); localtime_r(&now, &tme);
	strptime(inp, fmt, &tme); mktime(&tme);

	if ( argc == 4 ) {
		strncpy(outfmt, argv[3], sizeof(outfmt) - 1);
	}
	else {
		strncpy(outfmt, outdef, sizeof(outfmt) - 1);
	}

	strftime(out, sizeof(out) - 1, outfmt, &tme);
	printf("%s", out);

	exit(0);
}

