m4_define([[_HTML_HELPERS_OLDDIVNUM]],m4_divnum())m4_divert(-1)m4_dnl

m4_dnl
m4_dnl Some HTML helper macros
m4_dnl

m4_dnl Expand a list of items in the same way for each item.
m4_dnl Usage: _foreach([[<temp>]],[[<start><temp><end>]],
m4_dnl        [[<1st>]],[[<2nd>]],[[<3rd>]],[[...]],[[<nth>]])
m4_dnl Source: "Loops" in https://mbreen.com/m4.html
m4_dnl
m4_define([[_foreach]],[[m4_ifelse(m4_eval($#>2),1,[[m4_pushdef([[$1]],[[$3]])$2[[]]m4_popdef([[$1]])[[]]m4_ifelse(m4_eval($#>3),1,[[$0([[$1]],[[$2]],m4_shift(m4_shift(m4_shift($@))))]])]])]])

m4_dnl Define custom HTML tags
m4_dnl Usage: _TAG([[<tag-name>]],[[<tag-contents>]])
m4_dnl        _TAGC([[<tag-name>]],[[<tag-contents>]],[[<tag-metadata>]])
m4_dnl    _TAG:   Plain tags with content
m4_dnl    _TAGN:  Plain tags with content, w/newline
m4_dnl    _TAGC:  Styled, classed, or named tags with content
m4_dnl    _TAGCN: Styled, classed, or named tags with content, w/newline
m4_dnl
m4_define([[_TAG]],<[[$1]]>[[$2]]</[[$1]]>)
m4_define([[_TAGN]],<[[$1]]>[[$2]]</[[$1]]>
)
m4_define([[_TAGC]],<[[$1]] [[$3]]>[[$2]]</[[$1]]>)
m4_define([[_TAGCN]],<[[$1]] [[$3]]>[[$2]]</[[$1]]>
)

m4_dnl Quick unordered list of items
m4_dnl Usage: _UL([[<1st-list-item>]],[[<2nd>]],[[<3rd>]],[[...]],[[<Nth>]])
m4_dnl
m4_define([[_UL]],[[<ul>
_foreach([[_X]],[[_TAGN([[li]],[[_X]])]],$@)</ul>]])

m4_dnl Quick ordered list of items
m4_dnl Usage: _OL([[<1st-list-item>]],[[<2nd>]],[[<3rd>]],[[...]],[[<Nth>]])
m4_dnl
m4_define([[_OL]],[[<ol>
_foreach([[_X]],[[_TAGN([[li]],[[_X]])]],$@)</ol>]])

m4_dnl Quick table row of data cells
m4_dnl Make sure you provide the same number of cells in each row.
m4_dnl Usage: _TRD([[<1st-cell>]],[[<2nd>]],[[<3rd>]],[[...]],[[<Nth>]])
m4_dnl
m4_define([[_TRD]],[[    <tr>
_foreach([[_X]],[[      _TAGN([[td]],[[_X]])]],$@)    </tr>]])

m4_dnl Quick partial table row of data cells
m4_dnl Use this if you want the first cell in the row to be a header
m4_dnl cell instead of a data cell.  The <tr> and </tr> tags are NOT
m4_dnl included in this macro.
m4_dnl Usage: _TD([[<1st-cell>]],[[<2nd>]],[[<3rd>]],[[...]],[[<Nth>]])
m4_dnl
m4_define([[_TD]],[[_foreach([[_X]],[[_TAGN([[td]],[[_X]])]],$@)]])

m4_dnl Quick table row of header cells
m4_dnl Make sure you provide the same number of cells in each row.
m4_dnl Usage: _TRH([[<1st-cell>]],[[<2nd>]],[[<3rd>]],[[...]],[[<Nth>]])
m4_dnl
m4_define([[_TRH]],[[    <tr>
_foreach([[_X]],[[      _TAGN([[th]],[[_X]])]],$@)    </tr>]])

m4_dnl Table, THead, and TBody wrapper macros
m4_dnl Usage: _TABLE([[<content>]]), _THEAD([[<content>]]),
m4_dnl        _TBODY([[<content>]])
m4_dnl
m4_define([[_TABLE]],[[<table>
$1
</table>]])
m4_define([[_THEAD]],[[  <thead>
$1
  </thead>]])
m4_define([[_TBODY]],[[  <tbody>
$1
  </tbody>]])

m4_dnl Table, THead, and TBody wrapper macros, with metadata
m4_dnl Usage: _TABLEM([[<content>]],[[<meta>]]), _THEADM([[<content>]],[[<meta>]]),
m4_dnl        _TBODYM([[<content>]],[[<meta>]])
m4_dnl
m4_define([[_TABLEM]],[[<table [[$2]]>
$1
</table>]])
m4_define([[_THEADM]],[[  <thead [[$2]]>
$1
  </thead>]])
m4_define([[_TBODYM]],[[  <tbody [[$2]]>
$1
  </tbody>]])

m4_dnl Quick dictionary list item
m4_dnl Usage: _DICT([[<term>]],[[<definition>]])
m4_dnl
m4_define([[_DICT]],[[  <dt>$1</dt>
  <dd>$2</dd>
]])

m4_divert(_HTML_HELPERS_OLDDIVNUM)m4_dnl
